{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}
{$ifdef FPC} {$mode delphi} {$endif}
unit lpt;

interface

uses Windows, Messages, KOL {place your units here->}
{$IFDEF LAZIDE_MCK}, Forms, mirror, Classes, Controls, mckCtrls, mckObjs{,Graphics};
{$ELSE} ; {$ENDIF}

function Inp32(PortAdr: word): byte; stdcall; external 'inpout32.dll';
function Out32(PortAdr: word; Data: byte): byte; stdcall; external 'inpout32.dll';

type
  { TForm1 }
  {$I MCKfakeClasses.inc}
  {$IFDEF KOLCLASSES} TForm1 = class; PForm1 = TForm1; {$ELSE OBJECTS} PForm1 = ^TForm1; {$ENDIF CLASSES/OBJECTS}
  TForm1 = {$IFDEF KOLCLASSES}class{$ELSE}object{$ENDIF}({$IFDEF LAZIDE_MCK}TForm{$ELSE}TObj{$ENDIF})
    ComboBox1: TKOLComboBox;
    Form: PControl;
    GroupBox1: TKOLGroupBox;
    GroupBox2: TKOLGroupBox;
    GroupBox3: TKOLGroupBox;
    KOLForm1: TKOLForm;
    KOLLptPin: TKOLProject;
    LabelS1: TKOLLabel;
    LabelS2: TKOLLabel;
    LabelS3: TKOLLabel;
    LabelD1: TKOLLabel;
    LabelD2: TKOLLabel;
    LabelD3: TKOLLabel;
    LabelC1: TKOLLabel;
    LabelC2: TKOLLabel;
    LabelC3: TKOLLabel;
    PanelS6: TKOLPanel;
    PanelS7: TKOLPanel;
    PanelS2: TKOLPanel;
    PanelS3: TKOLPanel;
    PanelS4: TKOLPanel;
    PanelS5: TKOLPanel;
    PanelD0: TKOLPanel;
    PanelD1: TKOLPanel;
    PanelC2: TKOLPanel;
    PanelC3: TKOLPanel;
    PanelC4: TKOLPanel;
    PanelC5: TKOLPanel;
    PanelD2: TKOLPanel;
    PanelD3: TKOLPanel;
    PanelD4: TKOLPanel;
    PanelD5: TKOLPanel;
    PanelD6: TKOLPanel;
    PanelD7: TKOLPanel;
    PanelC0: TKOLPanel;
    PanelC1: TKOLPanel;
    Timer1: TKOLTimer;
    procedure KOLForm1Close(Sender: PObj; var Accept: Boolean);
    procedure Timer1Timer(Sender: PObj);
    procedure Pin2(Sender: PObj);
    procedure Pin3(Sender: PObj);
    procedure Pin4(Sender: PObj);
    procedure Pin5(Sender: PObj);
    procedure Pin6(Sender: PObj);
    procedure Pin7(Sender: PObj);
    procedure Pin8(Sender: PObj);
    procedure Pin9(Sender: PObj);
    procedure Pin14(Sender: PObj);
    procedure Pin16(Sender: PObj);
    procedure Pin17(Sender: PObj);
    procedure AckInEnable(Sender: PObj);
    procedure Direction(Sender: PObj);
    procedure ChangePort(Sender: PObj);
    procedure GetNameLpt(Sender: PObj);
    procedure Pin1(Sender: PObj);

  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1 {$IFDEF KOL_MCK} : PForm1 {$ELSE} : TForm1 {$ENDIF} ;
  Port: Integer;
  Da, Co, St: byte;


{$IFDEF KOL_MCK}
procedure NewForm1( var Result: PForm1; AParent: PControl );
{$ENDIF}

implementation

{$IFDEF KOL_MCK}
{$I lpt_1.inc}
{$ENDIF}

{ TForm1 }


procedure TForm1.Timer1Timer(Sender: PObj);
begin
 // читаем данные из порта
   Da:=Inp32(Port);    //регистр данных
   Co:=Inp32(Port+2);  //регистр управления
   St:=Inp32(Port+1);  //регистр состояния
   //выводим значения
   //DEC
   LabelD1.Caption:=Int2Ths(Da);
   LabelC1.Caption:=Int2Ths(Co);
   LabelS1.Caption:=Int2Ths(St);
   //HEX
   LabelD2.Caption:=Int2Hex(Da,2);
   LabelC2.Caption:=Int2Hex(Co,2);
   LabelS2.Caption:=Int2Hex(St,2);
   //BIN
   LabelD3.Caption:=BinStr(Da,8);
   LabelC3.Caption:=BinStr(Co,8);
   LabelS3.Caption:=BinStr(St,8);
   //индикация состояния PIN
   //DATA
  if Da and (1 shl 0)<>0 then PanelD0.Color:= clTeal else PanelD0.Color:= clBtnFace ;
  if Da and (1 shl 1)<>0 then PanelD1.Color:= clTeal else PanelD1.Color:= clBtnFace ;
  if Da and (1 shl 2)<>0 then PanelD2.Color:= clTeal else PanelD2.Color:= clBtnFace ;
  if Da and (1 shl 3)<>0 then PanelD3.Color:= clTeal else PanelD3.Color:= clBtnFace ;
  if Da and (1 shl 4)<>0 then PanelD4.Color:= clTeal else PanelD4.Color:= clBtnFace ;
  if Da and (1 shl 5)<>0 then PanelD5.Color:= clTeal else PanelD5.Color:= clBtnFace ;
  if Da and (1 shl 6)<>0 then PanelD6.Color:= clTeal else PanelD6.Color:= clBtnFace ;
  if Da and (1 shl 7)<>0 then PanelD7.Color:= clTeal else PanelD7.Color:= clBtnFace ;

    //CONTROL
    {CR:5 – Direction – бит управления направлением передачи (только для портов PS/2). Запись единицы переводит регистр данных в режим ввода.
     CR:4 – ACKINTEN (Ack Interrupt Enable) – единичное значение разрешает прерывание по спаду сигнала на линии Ack (сигнал запроса следующего байта).
     CR:3 – единичное значение бита соответствует низкому уровню на выходе SelectIn.
     CR:2 – нулевое значение бита соответствует низкому уровню на выходе Init.
     CR:1 - единичное значение бита соответствует низкому уровню на выходе AutoLF – сигналу на автоматический перевод строки (LF – Line Feed) по приему байта возврата каретки.
     CR:0 – единичное значение бита соответствует низкому уровню на выходе Strobe.}
  if Co and (1 shl 0)= 0 then PanelC0.Color:= clTeal else PanelC0.Color:= clBtnFace ;
  if Co and (1 shl 1)= 0 then PanelC1.Color:= clTeal else PanelC1.Color:= clBtnFace ;
  if Co and (1 shl 2)<>0 then PanelC2.Color:= clTeal else PanelC2.Color:= clBtnFace ;
  if Co and (1 shl 3)= 0 then PanelC3.Color:= clTeal else PanelC3.Color:= clBtnFace ;
  if Co and (1 shl 4)<>0 then PanelC4.Color:= clTeal else PanelC4.Color:= clBtnFace ;
  if Co and (1 shl 5)<>0 then PanelC5.Color:= clTeal else PanelC5.Color:= clBtnFace ;

   //STATUS
    {SR:7 – инверсное отображения состояния линии Busy;
    SR:6 – отображения состояния линии Ack;
    SR:5 – отображения состояния линии PaperEnd;
    SR:4 – отображения состояния линии Select;
    SR:3 – отображения состояния линии Error;
    SR:2 – PIRQ. Флаг прерывания по сигналу Ack. Разрешено, если 4-й бит в регистре CR = 1. }
  if St and (1 shl 2)<>0 then PanelS2.Color:= clTeal else PanelS2.Color:= clBtnFace ;
  if St and (1 shl 3)<>0 then PanelS3.Color:= clTeal else PanelS3.Color:= clBtnFace ;
  if St and (1 shl 4)<>0 then PanelS4.Color:= clTeal else PanelS4.Color:= clBtnFace ;
  if St and (1 shl 5)<>0 then PanelS5.Color:= clTeal else PanelS5.Color:= clBtnFace ;
  if St and (1 shl 6)<>0 then PanelS6.Color:= clTeal else PanelS6.Color:= clBtnFace ;
  if St and (1 shl 7)= 0 then PanelS7.Color:= clTeal else PanelS7.Color:= clBtnFace ;
end;

procedure TForm1.KOLForm1Close(Sender: PObj; var Accept: Boolean);
begin
  Timer1.Enabled:=False;
  if ShowMsg( 'Вы действительно хотите выйти?',MB_YESNO)=IDNO then
     begin
      Accept:=False  ;
      Timer1.Enabled:=True;
     end;
  Out32(Port,0);
end;


// процедуры переключения состоянием пинов
//DATA
procedure TForm1.Pin2(Sender: PObj);
begin
 Out32(Port,Da xor (1 shl 0));
end;

procedure TForm1.Pin3(Sender: PObj);
begin
  Out32(Port,Da xor (1 shl 1));
end;

procedure TForm1.Pin4(Sender: PObj);
begin
  Out32(Port,Da xor (1 shl 2));
end;

procedure TForm1.Pin5(Sender: PObj);
begin
  Out32(Port,Da xor (1 shl 3));
end;

procedure TForm1.Pin6(Sender: PObj);
begin
  Out32(Port,Da xor (1 shl 4));
end;

procedure TForm1.Pin7(Sender: PObj);
begin
  Out32(Port,Da xor (1 shl 5));
end;

procedure TForm1.Pin8(Sender: PObj);
begin
  Out32(Port,Da xor (1 shl 6));
end;

procedure TForm1.Pin9(Sender: PObj);
begin
  Out32(Port,Da xor (1 shl 7));
end;
// CONTROL
procedure TForm1.Pin1(Sender: PObj);
begin
  Out32(Port+2,Co xor (1 shl 0));
end;

procedure TForm1.Pin14(Sender: PObj);
begin
  Out32(Port+2,Co xor (1 shl 1));
end;

procedure TForm1.Pin16(Sender: PObj);
begin
  Out32(Port+2,Co xor (1 shl 2));
end;

procedure TForm1.Pin17(Sender: PObj);
begin
  Out32(Port+2,Co xor (1 shl 3));
end;

// дополнительные процедуры регистра Control

{Ack Interrupt Enable - CR:4 - единичное значение разрешает прерывание по
спаду сигнала на линии Ack (сигнал запроса следующего байта)}
procedure TForm1.AckInEnable(Sender: PObj);
begin
  Out32(Port+2,Co xor (1 shl 4));
end;

{ Direction - CR:5 – бит управления направлением передачи
Запись единицы переводит регистр данных в режим ввода }
procedure TForm1.Direction(Sender: PObj);
begin
  Out32(Port+2,Co xor (1 shl 5));
end;



procedure TForm1.GetNameLpt(Sender: PObj);
var
Key:HKey;
begin
ComboBox1.Clear;
Key := RegKeyOpenRead(HKEY_LOCAL_MACHINE,'HARDWARE\DEVICEMAP\PARALLEL PORTS');
if Key <>0 then
    if RegKeyGetStrEx(Key,'\Device\Parallel0')<>'' then ComboBox1.Add('LPT1');
    if RegKeyGetStrEx(Key,'\Device\Parallel1')<>'' then ComboBox1.Add('LPT2');
    if RegKeyGetStrEx(Key,'\Device\Parallel2')<>'' then ComboBox1.Add('LPT3');
RegKeyClose(Key);
 ChangePort(Sender);
end;

procedure TForm1.ChangePort(Sender: PObj);
begin
  if ComboBox1.Text='LPT1' then Port:=888;
 // if ComboBox1.Text='LPT2' then Port:=888;
//  if ComboBox1.Text='LPT3' then Port:=888;
  GroupBox1.Caption:=GroupBox1.Caption + Int2Hex(Port,3);
  GroupBox2.Caption:=GroupBox2.Caption + Int2Hex(Port+2,3);
  GroupBox3.Caption:=GroupBox3.Caption + Int2Hex(Port+1,3);
end;


initialization
{$IFNDEF KOL_MCK} {$I lpt.lrs} {$ENDIF}

end.








